/* 
CS262-002 Programming Assignment no 1
Solution Code by Zameer Sura				*/

#include<stdio.h>
#include<stdlib.h>

// Structure to hold the 2D axis of a box
typedef struct{
	int minX, maxX, minY, maxY,iso;
} Box;

/*
Function checks if two boxes interesct each other
Accepts: pointer to the array of boxes and 
the id of the two boxes to be compared
Returns: 1 if they intersect, 0 if they don't	*/
int checkIntersect(Box boxes[],int i,int j);

/*
Main Function
Takes the the number of boxes from the user and their 2D axis dimensions
and prints out the ids of the isolated boxes	*/
int main(){
	int i,j,numberOfBoxes=2;
	Box *boxes;			// Pointer of type Box
	printf("Please enter the number of boxes: ");
	scanf("%d", &numberOfBoxes);	// Accepts the number of boxes

	/* Allocates the address pointed by pointer boxes with memory 
	to store data for all te boxes*/
	boxes=(Box*) malloc(numberOfBoxes*sizeof(Box));	

	// Initializing the iso variable for all boxes to 0
	for(i=0;i<numberOfBoxes;i++){
		boxes[i].iso=0;
	}

	// Accepts the axis of the boxes from the user
	printf("Please enter the axis of the %d boxes"
			"(minX maxX minY maxY):\n",numberOfBoxes);
	for(i=0;i<numberOfBoxes;i++){
		scanf("%d %d %d %d",&boxes[i].minX ,&boxes[i].maxX ,
				&boxes[i].minY ,&boxes[i].maxY);
	}
	
	// Checks each box against each other if they intersect
	printf("\nIsolated Box ids are as follows:");
	for(i=0;i<numberOfBoxes;i++){
		// Only proceed if the box is not already found to intersect
		if(boxes[i].iso!=1){		
			for(j=0;j<numberOfBoxes;j++){
				if(i!=j){
					// If Boxes intersect set iso to 1
					if(checkIntersect(boxes,i,j)==1){
						boxes[i].iso=1;
						boxes[j].iso=1;
					}
				}		
			}
			// Print id if box is isolated
			if(boxes[i].iso==0){
				printf("\n%d",i);
			}
		}
	}
	printf("\n");
	return 0;
}

int checkIntersect(Box boxes[],int i,int j){
	// Check if the boxes do not intersect in the X dimensions
	if((boxes[i].minX<=boxes[j].minX && boxes[i].maxX<=boxes[j].minX) || 
		(boxes[i].minX>=boxes[j].maxX && boxes[i].maxX>=boxes[j].maxX)){
		return 0;
	// Check if the boxes do not intersect in the Y dimension
	}else if((boxes[i].minY<=boxes[j].minY && boxes[i].maxY<=boxes[j].minY) || 
		(boxes[i].minY>=boxes[j].maxY && boxes[i].maxY>=boxes[j].maxY)){
		return 0;
	}else{		// if the above conditions fail the boxes intersect
		return 1; 
	}
}
