/*
 * cs262, Fall 11
 * solution, PA1 section 5
 * 
 * J-M Lien
 * jmlien@cs.gmu.edu
 *
 */
 
#include <stdio.h>

//macro
#define sqr(x) ((x)*(x))

typedef unsigned int uint;

//
//check if two triangles are similar
//if so, returns 1, otherwise, returns 0
//
int similar(int tri1[], int tri2[]);

//compute the square length each edge of the given triangle
void edge_length_sqr(int tri[], uint len[]);

//determine the similarity based on the edge (square) length
//if so, returns 1, otherwise, returns 0
//d1~d3 are the edge (square) length of the first triangle
//D1~D3 are the edge (square) length of the second triangle
int similarE(uint d1, uint d2, uint d3, uint D1, uint D2, uint D3);

int main()
{
   int tri1[6], tri2[6]; //two triangles
   int i; //for loop index
   do{
	   //read first triangle
	   for(i=0;i<6;i++) if(scanf("%d", &tri1[i])==EOF) return 0;
	   
	   //read 2nd triangle
	   for(i=0;i<6;i++) if(scanf("%d", &tri2[i])==EOF) return 0;

	   //check if they are similar
	   if( similar(tri1, tri2) ) printf("similar\n");
	   else printf("not similar\n");
   }
   while(1);

   return 0;
}
 
//
//check if two triangles are similar
//if so, returns 1, otherwise, returns 0
//
int similar(int tri1[], int tri2[])
{
    //compute the square of the edge length of triangles 1 and 2
    uint el1[3], el2[3]; 
    edge_length_sqr(tri1,el1);
    edge_length_sqr(tri2,el2);
    
    //compare edge lengths
    if( similarE(el1[0],el1[1],el1[2],el2[0],el2[1],el2[2]) ) return 1;
    if( similarE(el1[1],el1[2],el1[0],el2[0],el2[1],el2[2]) ) return 1;
    if( similarE(el1[2],el1[0],el1[1],el2[0],el2[1],el2[2]) ) return 1;

	return 0;
}

//determine the similarity based on the edge (square) length
//if so, returns 1, otherwise, returns 0
//d1~d3 are the edge (square) length of the first triangle
//D1~D3 are the edge (square) length of the second triangle
int similarE(uint d1, uint d2, uint d3, uint D1, uint D2, uint D3)
{
    if(d1*D2!=d2*D1) return 0; //not similar
    if(d2*D3!=d3*D2) return 0; //not similar
    if(d1*D3!=d3*D1) return 0; //not similar
	return 1; //similar
}

//compute the square length of each edge of the given triangle
void edge_length_sqr(int tri[], uint len[])
{
    int i,j;
    for(i=0;i<3;i++){
      j=(i+1)%3; //the index of the next edge 
      len[i]=sqr(tri[j*2]-tri[i*2])+sqr(tri[j*2+1]-tri[i*2+1]); //square edge length
    }
}
