/**
* Programming Assignment #1, Section 005
* CS262, Fall 2011, Section 005
* Program assignment 1 (PA1) 
* Instructor: Jyh-Ming Lien, jmlien@cs.gmu.edu
*
* @author: Mohamed Elsabagh, melsabag@gmu.edu
* 9/14/2011 8.36 PM
*/

#include <stdio.h>

#define MAX_RERR 0.000001
#define sqr(x) ((x)*(x))

void  sort3(int a[]);
float absf(float f);
int   equf(float f1, float f2);

int main() {
  int t1v[3][2] = {{0,0}, {0,0}, {0,0}}; /* holds vertices of 1st triangle */
  int t2v[3][2] = {{0,0}, {0,0}, {0,0}}; /* holds vertices of 2nd triangle */

  while (EOF != scanf("%d %d %d %d %d %d %d %d %d %d %d %d", 
          &t1v[0][0], &t1v[0][1], &t1v[1][0], &t1v[1][1], &t1v[2][0], &t1v[2][1],
          &t2v[0][0], &t2v[0][1], &t2v[1][0], &t2v[1][1], &t2v[2][0], &t2v[2][1])) {
  
    /* square pairwise distances between the vertices of triangle 1 */
    int t1s2[] = {sqr(t1v[0][0] - t1v[1][0]) + sqr(t1v[0][1] - t1v[1][1]),
                  sqr(t1v[1][0] - t1v[2][0]) + sqr(t1v[1][1] - t1v[2][1]),
                  sqr(t1v[2][0] - t1v[0][0]) + sqr(t1v[2][1] - t1v[0][1])};

    /* square pairwise distances between the vertices of triangle 2 */
    int t2s2[] = {sqr(t2v[0][0] - t2v[1][0]) + sqr(t2v[0][1] - t2v[1][1]),
                  sqr(t2v[1][0] - t2v[2][0]) + sqr(t2v[1][1] - t2v[2][1]),
                  sqr(t2v[2][0] - t2v[0][0]) + sqr(t2v[2][1] - t2v[0][1])};

    /* sort and calculate the scaling ratio of each side */
    sort3(t1s2);
    sort3(t2s2);
    float scale1 = (float) t2s2[0] / t1s2[0];
    float scale2 = (float) t2s2[1] / t1s2[1];
    float scale3 = (float) t2s2[2] / t1s2[2];

    /* if all sides are scaled by the same factor, 
     * then the two triangles are similar (SSS test) */
    if (equf(scale1, scale2) && equf(scale2, scale3)) {
      printf("similar\n");
    } else {
      printf("not similar\n");
    }
  }

  return 0;
}

/* Sorts 3 integers using bubble sort */
void sort3(int a[]) {
  int tmp;
  if (a[0] > a[1]) {tmp = a[0]; a[0] = a[1]; a[1] = tmp;}
  if (a[1] > a[2]) {tmp = a[1]; a[1] = a[2]; a[2] = tmp;}
  if (a[0] > a[1]) {tmp = a[0]; a[0] = a[1]; a[1] = tmp;}
}

/* Gets the absolute value of a floating-point number by clearing the 
 * sign bit (Assumes IEEE 754 representation). 
 * @return Absolute value of f
 * @see http://en.wikipedia.org/wiki/IEEE_754-1985#Summary */
float absf(float f) {
  int x = *(int*) &f;
  x &= 0x7FFFFFFF;
  return *(float*)&x;
}

/* Checks for equality by checking if the relative error is less than a
 * predefined maximum (MAX_RERR)
 * @return 0 for non-equal, otherwise for equal */
int equf(float f1, float f2) {
  if (f1 == f2) return 1; /* avoids zero/zero divisions */
  if (f1 < f2) {
    return absf(f1 - f2) / f2 <= MAX_RERR;
  } else {
    return absf(f2 - f1) / f1 <= MAX_RERR;
  }
}
